# Copyright 2014-2017 Intel Corporation
# All Rights Reserved.
#
# If this  software was obtained  under the  Intel Simplified  Software License,
# the following terms apply:
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#
#
# If this  software  was obtained  under the  Apache License,  Version  2.0 (the
# "License"), the following terms apply:
#
# You may  not use this  file except  in compliance  with  the License.  You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
#
#
# Unless  required  by   applicable  law  or  agreed  to  in  writing,  software
# distributed under the License  is distributed  on an  "AS IS"  BASIS,  WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the   License  for the   specific  language   governing   permissions  and
# limitations under the License.


from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_em_gmm', [dirname(__file__)])
        except ImportError:
            import _em_gmm
            return _em_gmm
        if fp is not None:
            try:
                _mod = imp.load_module('_em_gmm', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _em_gmm = swig_import_helper()
    del swig_import_helper
else:
    import _em_gmm
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils
import daal.algorithms.covariance
import daal.algorithms.em_gmm.init
import daal.algorithms.engines.mt19937
import daal.algorithms.engines

_em_gmm.full_swigconstant(_em_gmm)
full = _em_gmm.full

_em_gmm.diagonal_swigconstant(_em_gmm)
diagonal = _em_gmm.diagonal

_em_gmm.defaultDense_swigconstant(_em_gmm)
defaultDense = _em_gmm.defaultDense

_em_gmm.data_swigconstant(_em_gmm)
data = _em_gmm.data

_em_gmm.inputWeights_swigconstant(_em_gmm)
inputWeights = _em_gmm.inputWeights

_em_gmm.inputMeans_swigconstant(_em_gmm)
inputMeans = _em_gmm.inputMeans

_em_gmm.lastInputId_swigconstant(_em_gmm)
lastInputId = _em_gmm.lastInputId

_em_gmm.inputCovariances_swigconstant(_em_gmm)
inputCovariances = _em_gmm.inputCovariances

_em_gmm.lastInputCovariancesId_swigconstant(_em_gmm)
lastInputCovariancesId = _em_gmm.lastInputCovariancesId

_em_gmm.inputValues_swigconstant(_em_gmm)
inputValues = _em_gmm.inputValues

_em_gmm.lastInputValuesId_swigconstant(_em_gmm)
lastInputValuesId = _em_gmm.lastInputValuesId

_em_gmm.weights_swigconstant(_em_gmm)
weights = _em_gmm.weights

_em_gmm.means_swigconstant(_em_gmm)
means = _em_gmm.means

_em_gmm.goalFunction_swigconstant(_em_gmm)
goalFunction = _em_gmm.goalFunction

_em_gmm.nIterations_swigconstant(_em_gmm)
nIterations = _em_gmm.nIterations

_em_gmm.lastResultId_swigconstant(_em_gmm)
lastResultId = _em_gmm.lastResultId

_em_gmm.covariances_swigconstant(_em_gmm)
covariances = _em_gmm.covariances

_em_gmm.lastResultCovariancesId_swigconstant(_em_gmm)
lastResultCovariancesId = _em_gmm.lastResultCovariancesId
class Parameter(daal.algorithms.Parameter):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _em_gmm.new_Parameter(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _em_gmm.delete_Parameter
    __del__ = lambda self: None

    def check(self):
        return _em_gmm.Parameter_check(self)
    __swig_setmethods__["nComponents"] = _em_gmm.Parameter_nComponents_set
    __swig_getmethods__["nComponents"] = _em_gmm.Parameter_nComponents_get
    if _newclass:
        nComponents = _swig_property(_em_gmm.Parameter_nComponents_get, _em_gmm.Parameter_nComponents_set)
    __swig_setmethods__["maxIterations"] = _em_gmm.Parameter_maxIterations_set
    __swig_getmethods__["maxIterations"] = _em_gmm.Parameter_maxIterations_get
    if _newclass:
        maxIterations = _swig_property(_em_gmm.Parameter_maxIterations_get, _em_gmm.Parameter_maxIterations_set)
    __swig_setmethods__["accuracyThreshold"] = _em_gmm.Parameter_accuracyThreshold_set
    __swig_getmethods__["accuracyThreshold"] = _em_gmm.Parameter_accuracyThreshold_get
    if _newclass:
        accuracyThreshold = _swig_property(_em_gmm.Parameter_accuracyThreshold_get, _em_gmm.Parameter_accuracyThreshold_set)
    __swig_setmethods__["covariance"] = _em_gmm.Parameter_covariance_set
    __swig_getmethods__["covariance"] = _em_gmm.Parameter_covariance_get
    if _newclass:
        covariance = _swig_property(_em_gmm.Parameter_covariance_get, _em_gmm.Parameter_covariance_set)
    __swig_setmethods__["regularizationFactor"] = _em_gmm.Parameter_regularizationFactor_set
    __swig_getmethods__["regularizationFactor"] = _em_gmm.Parameter_regularizationFactor_get
    if _newclass:
        regularizationFactor = _swig_property(_em_gmm.Parameter_regularizationFactor_get, _em_gmm.Parameter_regularizationFactor_set)
    __swig_setmethods__["covarianceStorage"] = _em_gmm.Parameter_covarianceStorage_set
    __swig_getmethods__["covarianceStorage"] = _em_gmm.Parameter_covarianceStorage_get
    if _newclass:
        covarianceStorage = _swig_property(_em_gmm.Parameter_covarianceStorage_get, _em_gmm.Parameter_covarianceStorage_set)
Parameter_swigregister = _em_gmm.Parameter_swigregister
Parameter_swigregister(Parameter)

class Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _em_gmm.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _em_gmm.delete_Input
    __del__ = lambda self: None

    def setTable(self, id, ptr):
        return _em_gmm.Input_setTable(self, id, ptr)

    def setCovariances(self, id, ptr):
        return _em_gmm.Input_setCovariances(self, id, ptr)

    def setValues(self, id, ptr):
        return _em_gmm.Input_setValues(self, id, ptr)

    def getTable(self, id):
        return _em_gmm.Input_getTable(self, id)

    def getCovariances(self, *args):
        return _em_gmm.Input_getCovariances(self, *args)

    def check(self, par, method):
        return _em_gmm.Input_check(self, par, method)
Input_swigregister = _em_gmm.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _em_gmm.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_em_gmm.Result_serializationTag)

    def getSerializationTag(self):
        return _em_gmm.Result_getSerializationTag(self)

    def __init__(self):
        this = _em_gmm.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _em_gmm.delete_Result
    __del__ = lambda self: None

    def setResult(self, id, ptr):
        return _em_gmm.Result_setResult(self, id, ptr)

    def setCovariances(self, id, ptr):
        return _em_gmm.Result_setCovariances(self, id, ptr)

    def getResult(self, id):
        return _em_gmm.Result_getResult(self, id)

    def getCovariances(self, *args):
        return _em_gmm.Result_getCovariances(self, *args)

    def check(self, input, par, method):
        return _em_gmm.Result_check(self, input, par, method)

    def allocate_Float64(self, input, parameter, method):
        r"""
This function is specialized for float64"""
        return _em_gmm.Result_allocate_Float64(self, input, parameter, method)


    def allocate_Float32(self, input, parameter, method):
        r"""
This function is specialized for float32"""
        return _em_gmm.Result_allocate_Float32(self, input, parameter, method)

Result_swigregister = _em_gmm.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _em_gmm.Result_serializationTag()
Result_serializationTag = _em_gmm.Result_serializationTag

class Batch_Float64DefaultDense(daal.algorithms.Analysis_Batch):
    r"""
This class is an alias of Batch(fptype=float64, method=daal.algorithms.em_gmm.defaultDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64DefaultDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _em_gmm.new_Batch_Float64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _em_gmm.Batch_Float64DefaultDense_getMethod(self)

    def getResult(self):
        return _em_gmm.Batch_Float64DefaultDense_getResult(self)

    def setResult(self, result):
        return _em_gmm.Batch_Float64DefaultDense_setResult(self, result)

    def clone(self):
        return _em_gmm.Batch_Float64DefaultDense_clone(self)
    __swig_setmethods__["input"] = _em_gmm.Batch_Float64DefaultDense_input_set
    __swig_getmethods__["input"] = _em_gmm.Batch_Float64DefaultDense_input_get
    if _newclass:
        input = _swig_property(_em_gmm.Batch_Float64DefaultDense_input_get, _em_gmm.Batch_Float64DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _em_gmm.Batch_Float64DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _em_gmm.Batch_Float64DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_em_gmm.Batch_Float64DefaultDense_parameter_get, _em_gmm.Batch_Float64DefaultDense_parameter_set)

    def compute(self):
        return _em_gmm.Batch_Float64DefaultDense_compute(self)
    __swig_destroy__ = _em_gmm.delete_Batch_Float64DefaultDense
    __del__ = lambda self: None
Batch_Float64DefaultDense_swigregister = _em_gmm.Batch_Float64DefaultDense_swigregister
Batch_Float64DefaultDense_swigregister(Batch_Float64DefaultDense)

class Batch_Float32DefaultDense(daal.algorithms.Analysis_Batch):
    r"""
This class is an alias of Batch(fptype=float32, method=daal.algorithms.em_gmm.defaultDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32DefaultDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _em_gmm.new_Batch_Float32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getMethod(self):
        return _em_gmm.Batch_Float32DefaultDense_getMethod(self)

    def getResult(self):
        return _em_gmm.Batch_Float32DefaultDense_getResult(self)

    def setResult(self, result):
        return _em_gmm.Batch_Float32DefaultDense_setResult(self, result)

    def clone(self):
        return _em_gmm.Batch_Float32DefaultDense_clone(self)
    __swig_setmethods__["input"] = _em_gmm.Batch_Float32DefaultDense_input_set
    __swig_getmethods__["input"] = _em_gmm.Batch_Float32DefaultDense_input_get
    if _newclass:
        input = _swig_property(_em_gmm.Batch_Float32DefaultDense_input_get, _em_gmm.Batch_Float32DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _em_gmm.Batch_Float32DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _em_gmm.Batch_Float32DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_em_gmm.Batch_Float32DefaultDense_parameter_get, _em_gmm.Batch_Float32DefaultDense_parameter_set)

    def compute(self):
        return _em_gmm.Batch_Float32DefaultDense_compute(self)
    __swig_destroy__ = _em_gmm.delete_Batch_Float32DefaultDense
    __del__ = lambda self: None
Batch_Float32DefaultDense_swigregister = _em_gmm.Batch_Float32DefaultDense_swigregister
Batch_Float32DefaultDense_swigregister(Batch_Float32DefaultDense)

from numpy import float64, float32, intc

class Batch(object):
    r"""Factory class for different types of Batch."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' not in kwargs or kwargs['fptype'] == float64:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float64DefaultDense(*args)
        if 'fptype' in kwargs and kwargs['fptype'] == float32:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float32DefaultDense(*args)

        raise RuntimeError("No appropriate constructor found for Batch")


# This file is compatible with both classic and new-style classes.


