# Copyright 2014-2017 Intel Corporation
# All Rights Reserved.
#
# If this  software was obtained  under the  Intel Simplified  Software License,
# the following terms apply:
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#
#
# If this  software  was obtained  under the  Apache License,  Version  2.0 (the
# "License"), the following terms apply:
#
# You may  not use this  file except  in compliance  with  the License.  You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
#
#
# Unless  required  by   applicable  law  or  agreed  to  in  writing,  software
# distributed under the License  is distributed  on an  "AS IS"  BASIS,  WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the   License  for the   specific  language   governing   permissions  and
# limitations under the License.


from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_prediction14', [dirname(__file__)])
        except ImportError:
            import _prediction14
            return _prediction14
        if fp is not None:
            try:
                _mod = imp.load_module('_prediction14', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _prediction14 = swig_import_helper()
    del swig_import_helper
else:
    import _prediction14
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils
import daal.algorithms.neural_networks.layers.forward
import daal.algorithms.neural_networks.layers
import daal.algorithms.neural_networks.initializers
import daal.algorithms.neural_networks
import daal.algorithms.neural_networks.layers.backward
import daal.algorithms.engines.mt19937
import daal.algorithms.engines

_prediction14.defaultDense_swigconstant(_prediction14)
defaultDense = _prediction14.defaultDense

_prediction14.feedforwardDense_swigconstant(_prediction14)
feedforwardDense = _prediction14.feedforwardDense

_prediction14.prediction_swigconstant(_prediction14)
prediction = _prediction14.prediction

_prediction14.lastResultId_swigconstant(_prediction14)
lastResultId = _prediction14.lastResultId

_prediction14.predictionCollection_swigconstant(_prediction14)
predictionCollection = _prediction14.predictionCollection

_prediction14.lastResultCollectionId_swigconstant(_prediction14)
lastResultCollectionId = _prediction14.lastResultCollectionId
class Result(daal.algorithms.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _prediction14.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_prediction14.Result_serializationTag)

    def getSerializationTag(self):
        return _prediction14.Result_getSerializationTag(self)

    def __init__(self):
        this = _prediction14.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this

    def getResult(self, id):
        return _prediction14.Result_getResult(self, id)

    def getResultCollection(self, id):
        return _prediction14.Result_getResultCollection(self, id)

    def get(self, id, key):
        return _prediction14.Result_get(self, id, key)

    def setResult(self, id, value):
        return _prediction14.Result_setResult(self, id, value)

    def setResultCollection(self, id, value):
        return _prediction14.Result_setResultCollection(self, id, value)

    def add(self, id, key, value):
        return _prediction14.Result_add(self, id, key, value)

    def check(self, input, par, method):
        return _prediction14.Result_check(self, input, par, method)

    def allocate_Float64(self, input, parameter, method):
        r"""
This function is specialized for float64"""
        return _prediction14.Result_allocate_Float64(self, input, parameter, method)


    def allocate_Float32(self, input, parameter, method):
        r"""
This function is specialized for float32"""
        return _prediction14.Result_allocate_Float32(self, input, parameter, method)

    __swig_destroy__ = _prediction14.delete_Result
    __del__ = lambda self: None
Result_swigregister = _prediction14.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _prediction14.Result_serializationTag()
Result_serializationTag = _prediction14.Result_serializationTag

class Parameter(daal.algorithms.Parameter):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter, name)
    __repr__ = _swig_repr

    def __init__(self, batchSize_=1, allocateWeightsAndBiases_=False):
        this = _prediction14.new_Parameter(batchSize_, allocateWeightsAndBiases_)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_setmethods__["batchSize"] = _prediction14.Parameter_batchSize_set
    __swig_getmethods__["batchSize"] = _prediction14.Parameter_batchSize_get
    if _newclass:
        batchSize = _swig_property(_prediction14.Parameter_batchSize_get, _prediction14.Parameter_batchSize_set)
    __swig_setmethods__["allocateWeightsAndBiases"] = _prediction14.Parameter_allocateWeightsAndBiases_set
    __swig_getmethods__["allocateWeightsAndBiases"] = _prediction14.Parameter_allocateWeightsAndBiases_get
    if _newclass:
        allocateWeightsAndBiases = _swig_property(_prediction14.Parameter_allocateWeightsAndBiases_get, _prediction14.Parameter_allocateWeightsAndBiases_set)
    __swig_destroy__ = _prediction14.delete_Parameter
    __del__ = lambda self: None
Parameter_swigregister = _prediction14.Parameter_swigregister
Parameter_swigregister(Parameter)

class Model(daal.algorithms.neural_networks.ModelImpl):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.neural_networks.ModelImpl]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Model, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.neural_networks.ModelImpl]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Model, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _prediction14.Model_serializationTag
    if _newclass:
        serializationTag = staticmethod(_prediction14.Model_serializationTag)

    def getSerializationTag(self):
        return _prediction14.Model_getSerializationTag(self)

    def __init__(self, *args):
        this = _prediction14.new_Model(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_getmethods__["create"] = lambda x: _prediction14.Model_create
    if _newclass:
        create = staticmethod(_prediction14.Model_create)
    __swig_destroy__ = _prediction14.delete_Model
    __del__ = lambda self: None

    def setLayers(self, forwardLayers, nextLayers):
        return _prediction14.Model_setLayers(self, forwardLayers, nextLayers)

    def getLayers(self):
        return _prediction14.Model_getLayers(self)

    def getLayer(self, index):
        return _prediction14.Model_getLayer(self, index)

    def allocate_Float64(self, sampleSize, parameter=None):
        r"""
This function is specialized for float64"""
        return _prediction14.Model_allocate_Float64(self, sampleSize, parameter)


    def allocate_Float32(self, sampleSize, parameter=None):
        r"""
This function is specialized for float32"""
        return _prediction14.Model_allocate_Float32(self, sampleSize, parameter)

Model_swigregister = _prediction14.Model_swigregister
Model_swigregister(Model)

def Model_serializationTag():
    return _prediction14.Model_serializationTag()
Model_serializationTag = _prediction14.Model_serializationTag

def Model_create(*args):
    return _prediction14.Model_create(*args)
Model_create = _prediction14.Model_create

def Model_Float64(forwardLayersForModel, nextLayersForModel, dummy, storeWeightsInTable):
    val = _prediction14.new_Model_Float64(forwardLayersForModel, nextLayersForModel, dummy, storeWeightsInTable)
    return val

def Model_Float32(forwardLayersForModel, nextLayersForModel, dummy, storeWeightsInTable):
    val = _prediction14.new_Model_Float32(forwardLayersForModel, nextLayersForModel, dummy, storeWeightsInTable)
    return val


_prediction14.data_swigconstant(_prediction14)
data = _prediction14.data

_prediction14.lastTensorInputId_swigconstant(_prediction14)
lastTensorInputId = _prediction14.lastTensorInputId

_prediction14.model_swigconstant(_prediction14)
model = _prediction14.model

_prediction14.lastModelInputId_swigconstant(_prediction14)
lastModelInputId = _prediction14.lastModelInputId
class Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _prediction14.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction14.delete_Input
    __del__ = lambda self: None

    def getTensorInput(self, id):
        return _prediction14.Input_getTensorInput(self, id)

    def setTensorInput(self, id, value):
        return _prediction14.Input_setTensorInput(self, id, value)

    def getModelInput(self, id):
        return _prediction14.Input_getModelInput(self, id)

    def setModelInput(self, id, value):
        return _prediction14.Input_setModelInput(self, id, value)

    def check(self, par, method):
        return _prediction14.Input_check(self, par, method)
Input_swigregister = _prediction14.Input_swigregister
Input_swigregister(Input)

class Topology(daal.Base):
    __swig_setmethods__ = {}
    for _s in [daal.Base]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Topology, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.Base]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Topology, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _prediction14.new_Topology(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def size(self):
        return _prediction14.Topology_size(self)

    def push_back(self, layer):
        return _prediction14.Topology_push_back(self, layer)

    def add(self, *args):
        return _prediction14.Topology_add(self, *args)

    def clear(self):
        return _prediction14.Topology_clear(self)

    def get(self, *args):
        return _prediction14.Topology_get(self, *args)

    def addNext(self, index, next):
        return _prediction14.Topology_addNext(self, index, next)

    def __getitem__(self, i):
        return _prediction14.Topology___getitem__(self, i)

    def __setitem__(self, i, v):
        return _prediction14.Topology___setitem__(self, i, v)
    __swig_destroy__ = _prediction14.delete_Topology
    __del__ = lambda self: None
Topology_swigregister = _prediction14.Topology_swigregister
Topology_swigregister(Topology)

class Batch_Float64FeedforwardDense(daal.algorithms.Prediction):
    r"""
This class is an alias of Batch(fptype=float64, method=daal.algorithms.neural_networks.prediction.feedforwardDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Prediction]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64FeedforwardDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Prediction]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64FeedforwardDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _prediction14.new_Batch_Float64FeedforwardDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction14.delete_Batch_Float64FeedforwardDense
    __del__ = lambda self: None

    def getResult(self):
        return _prediction14.Batch_Float64FeedforwardDense_getResult(self)

    def setResult(self, res):
        return _prediction14.Batch_Float64FeedforwardDense_setResult(self, res)

    def clone(self):
        return _prediction14.Batch_Float64FeedforwardDense_clone(self)

    def getMethod(self):
        return _prediction14.Batch_Float64FeedforwardDense_getMethod(self)
    __swig_setmethods__["input"] = _prediction14.Batch_Float64FeedforwardDense_input_set
    __swig_getmethods__["input"] = _prediction14.Batch_Float64FeedforwardDense_input_get
    if _newclass:
        input = _swig_property(_prediction14.Batch_Float64FeedforwardDense_input_get, _prediction14.Batch_Float64FeedforwardDense_input_set)
    __swig_setmethods__["parameter"] = _prediction14.Batch_Float64FeedforwardDense_parameter_set
    __swig_getmethods__["parameter"] = _prediction14.Batch_Float64FeedforwardDense_parameter_get
    if _newclass:
        parameter = _swig_property(_prediction14.Batch_Float64FeedforwardDense_parameter_get, _prediction14.Batch_Float64FeedforwardDense_parameter_set)

    def compute(self):
        return _prediction14.Batch_Float64FeedforwardDense_compute(self)
Batch_Float64FeedforwardDense_swigregister = _prediction14.Batch_Float64FeedforwardDense_swigregister
Batch_Float64FeedforwardDense_swigregister(Batch_Float64FeedforwardDense)

class Batch_Float32FeedforwardDense(daal.algorithms.Prediction):
    r"""
This class is an alias of Batch(fptype=float32, method=daal.algorithms.neural_networks.prediction.feedforwardDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Prediction]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32FeedforwardDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Prediction]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32FeedforwardDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _prediction14.new_Batch_Float32FeedforwardDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _prediction14.delete_Batch_Float32FeedforwardDense
    __del__ = lambda self: None

    def getResult(self):
        return _prediction14.Batch_Float32FeedforwardDense_getResult(self)

    def setResult(self, res):
        return _prediction14.Batch_Float32FeedforwardDense_setResult(self, res)

    def clone(self):
        return _prediction14.Batch_Float32FeedforwardDense_clone(self)

    def getMethod(self):
        return _prediction14.Batch_Float32FeedforwardDense_getMethod(self)
    __swig_setmethods__["input"] = _prediction14.Batch_Float32FeedforwardDense_input_set
    __swig_getmethods__["input"] = _prediction14.Batch_Float32FeedforwardDense_input_get
    if _newclass:
        input = _swig_property(_prediction14.Batch_Float32FeedforwardDense_input_get, _prediction14.Batch_Float32FeedforwardDense_input_set)
    __swig_setmethods__["parameter"] = _prediction14.Batch_Float32FeedforwardDense_parameter_set
    __swig_getmethods__["parameter"] = _prediction14.Batch_Float32FeedforwardDense_parameter_get
    if _newclass:
        parameter = _swig_property(_prediction14.Batch_Float32FeedforwardDense_parameter_get, _prediction14.Batch_Float32FeedforwardDense_parameter_set)

    def compute(self):
        return _prediction14.Batch_Float32FeedforwardDense_compute(self)
Batch_Float32FeedforwardDense_swigregister = _prediction14.Batch_Float32FeedforwardDense_swigregister
Batch_Float32FeedforwardDense_swigregister(Batch_Float32FeedforwardDense)

from numpy import float64, float32, intc

class Batch(object):
    r"""Factory class for different types of Batch."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' in kwargs and kwargs['fptype'] == float64:
            if 'method' not in kwargs or kwargs['method'] == feedforwardDense:
                return Batch_Float64FeedforwardDense(*args)
        if 'fptype' not in kwargs or kwargs['fptype'] == float32:
            if 'method' not in kwargs or kwargs['method'] == feedforwardDense:
                return Batch_Float32FeedforwardDense(*args)

        raise RuntimeError("No appropriate constructor found for Batch")


# This file is compatible with both classic and new-style classes.


