# Copyright 2014-2017 Intel Corporation
# All Rights Reserved.
#
# If this  software was obtained  under the  Intel Simplified  Software License,
# the following terms apply:
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#
#
# If this  software  was obtained  under the  Apache License,  Version  2.0 (the
# "License"), the following terms apply:
#
# You may  not use this  file except  in compliance  with  the License.  You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
#
#
# Unless  required  by   applicable  law  or  agreed  to  in  writing,  software
# distributed under the License  is distributed  on an  "AS IS"  BASIS,  WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the   License  for the   specific  language   governing   permissions  and
# limitations under the License.


from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_zscore', [dirname(__file__)])
        except ImportError:
            import _zscore
            return _zscore
        if fp is not None:
            try:
                _mod = imp.load_module('_zscore', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _zscore = swig_import_helper()
    del swig_import_helper
else:
    import _zscore
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal.algorithms.low_order_moments
import daal.algorithms
import daal.data_management
import daal
import daal.services
import daal.data_management.data_feature_utils

_zscore.defaultDense_swigconstant(_zscore)
defaultDense = _zscore.defaultDense

_zscore.sumDense_swigconstant(_zscore)
sumDense = _zscore.sumDense

_zscore.data_swigconstant(_zscore)
data = _zscore.data

_zscore.lastInputId_swigconstant(_zscore)
lastInputId = _zscore.lastInputId

_zscore.normalizedData_swigconstant(_zscore)
normalizedData = _zscore.normalizedData

_zscore.lastResultId_swigconstant(_zscore)
lastResultId = _zscore.lastResultId
class Input(daal.algorithms.Input):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Input, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Input]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Input, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _zscore.new_Input(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Input
    __del__ = lambda self: None

    def get(self, id):
        return _zscore.Input_get(self, id)

    def set(self, id, ptr):
        return _zscore.Input_set(self, id, ptr)

    def check(self, par, method):
        return _zscore.Input_check(self, par, method)
Input_swigregister = _zscore.Input_swigregister
Input_swigregister(Input)

class Result(daal.algorithms.Result):
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Result, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Result]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Result, name)
    __repr__ = _swig_repr
    __swig_getmethods__["serializationTag"] = lambda x: _zscore.Result_serializationTag
    if _newclass:
        serializationTag = staticmethod(_zscore.Result_serializationTag)

    def getSerializationTag(self):
        return _zscore.Result_getSerializationTag(self)

    def __init__(self):
        this = _zscore.new_Result()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Result
    __del__ = lambda self: None

    def get(self, id):
        return _zscore.Result_get(self, id)

    def set(self, id, value):
        return _zscore.Result_set(self, id, value)

    def check(self, arg2, par, method):
        return _zscore.Result_check(self, arg2, par, method)

    def allocate_Float64(self, input, method):
        r"""
This function is specialized for float64"""
        return _zscore.Result_allocate_Float64(self, input, method)


    def allocate_Float32(self, input, method):
        r"""
This function is specialized for float32"""
        return _zscore.Result_allocate_Float32(self, input, method)

Result_swigregister = _zscore.Result_swigregister
Result_swigregister(Result)

def Result_serializationTag():
    return _zscore.Result_serializationTag()
Result_serializationTag = _zscore.Result_serializationTag

class Batch_Float64DefaultDense(daal.algorithms.Analysis_Batch):
    r"""
This class is an alias of Batch(fptype=float64, method=daal.algorithms.normalization.zscore.defaultDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _zscore.Batch_Float64DefaultDense_input_set
    __swig_getmethods__["input"] = _zscore.Batch_Float64DefaultDense_input_get
    if _newclass:
        input = _swig_property(_zscore.Batch_Float64DefaultDense_input_get, _zscore.Batch_Float64DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _zscore.Batch_Float64DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _zscore.Batch_Float64DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_zscore.Batch_Float64DefaultDense_parameter_get, _zscore.Batch_Float64DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _zscore.new_Batch_Float64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Batch_Float64DefaultDense
    __del__ = lambda self: None

    def getMethod(self):
        return _zscore.Batch_Float64DefaultDense_getMethod(self)

    def getResult(self):
        return _zscore.Batch_Float64DefaultDense_getResult(self)

    def setResult(self, result):
        return _zscore.Batch_Float64DefaultDense_setResult(self, result)

    def clone(self):
        return _zscore.Batch_Float64DefaultDense_clone(self)

    def compute(self):
        return _zscore.Batch_Float64DefaultDense_compute(self)
Batch_Float64DefaultDense_swigregister = _zscore.Batch_Float64DefaultDense_swigregister
Batch_Float64DefaultDense_swigregister(Batch_Float64DefaultDense)

class Batch_Float64SumDense(daal.algorithms.Analysis_Batch):
    r"""
This class is an alias of Batch(fptype=float64, method=daal.algorithms.normalization.zscore.sumDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float64SumDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float64SumDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _zscore.Batch_Float64SumDense_input_set
    __swig_getmethods__["input"] = _zscore.Batch_Float64SumDense_input_get
    if _newclass:
        input = _swig_property(_zscore.Batch_Float64SumDense_input_get, _zscore.Batch_Float64SumDense_input_set)
    __swig_setmethods__["parameter"] = _zscore.Batch_Float64SumDense_parameter_set
    __swig_getmethods__["parameter"] = _zscore.Batch_Float64SumDense_parameter_get
    if _newclass:
        parameter = _swig_property(_zscore.Batch_Float64SumDense_parameter_get, _zscore.Batch_Float64SumDense_parameter_set)

    def __init__(self, *args):
        this = _zscore.new_Batch_Float64SumDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Batch_Float64SumDense
    __del__ = lambda self: None

    def getMethod(self):
        return _zscore.Batch_Float64SumDense_getMethod(self)

    def getResult(self):
        return _zscore.Batch_Float64SumDense_getResult(self)

    def setResult(self, result):
        return _zscore.Batch_Float64SumDense_setResult(self, result)

    def clone(self):
        return _zscore.Batch_Float64SumDense_clone(self)

    def compute(self):
        return _zscore.Batch_Float64SumDense_compute(self)
Batch_Float64SumDense_swigregister = _zscore.Batch_Float64SumDense_swigregister
Batch_Float64SumDense_swigregister(Batch_Float64SumDense)

class Batch_Float32DefaultDense(daal.algorithms.Analysis_Batch):
    r"""
This class is an alias of Batch(fptype=float32, method=daal.algorithms.normalization.zscore.defaultDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32DefaultDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _zscore.Batch_Float32DefaultDense_input_set
    __swig_getmethods__["input"] = _zscore.Batch_Float32DefaultDense_input_get
    if _newclass:
        input = _swig_property(_zscore.Batch_Float32DefaultDense_input_get, _zscore.Batch_Float32DefaultDense_input_set)
    __swig_setmethods__["parameter"] = _zscore.Batch_Float32DefaultDense_parameter_set
    __swig_getmethods__["parameter"] = _zscore.Batch_Float32DefaultDense_parameter_get
    if _newclass:
        parameter = _swig_property(_zscore.Batch_Float32DefaultDense_parameter_get, _zscore.Batch_Float32DefaultDense_parameter_set)

    def __init__(self, *args):
        this = _zscore.new_Batch_Float32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Batch_Float32DefaultDense
    __del__ = lambda self: None

    def getMethod(self):
        return _zscore.Batch_Float32DefaultDense_getMethod(self)

    def getResult(self):
        return _zscore.Batch_Float32DefaultDense_getResult(self)

    def setResult(self, result):
        return _zscore.Batch_Float32DefaultDense_setResult(self, result)

    def clone(self):
        return _zscore.Batch_Float32DefaultDense_clone(self)

    def compute(self):
        return _zscore.Batch_Float32DefaultDense_compute(self)
Batch_Float32DefaultDense_swigregister = _zscore.Batch_Float32DefaultDense_swigregister
Batch_Float32DefaultDense_swigregister(Batch_Float32DefaultDense)

class Batch_Float32SumDense(daal.algorithms.Analysis_Batch):
    r"""
This class is an alias of Batch(fptype=float32, method=daal.algorithms.normalization.zscore.sumDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Batch_Float32SumDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Analysis_Batch]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Batch_Float32SumDense, name)
    __repr__ = _swig_repr
    __swig_setmethods__["input"] = _zscore.Batch_Float32SumDense_input_set
    __swig_getmethods__["input"] = _zscore.Batch_Float32SumDense_input_get
    if _newclass:
        input = _swig_property(_zscore.Batch_Float32SumDense_input_get, _zscore.Batch_Float32SumDense_input_set)
    __swig_setmethods__["parameter"] = _zscore.Batch_Float32SumDense_parameter_set
    __swig_getmethods__["parameter"] = _zscore.Batch_Float32SumDense_parameter_get
    if _newclass:
        parameter = _swig_property(_zscore.Batch_Float32SumDense_parameter_get, _zscore.Batch_Float32SumDense_parameter_set)

    def __init__(self, *args):
        this = _zscore.new_Batch_Float32SumDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Batch_Float32SumDense
    __del__ = lambda self: None

    def getMethod(self):
        return _zscore.Batch_Float32SumDense_getMethod(self)

    def getResult(self):
        return _zscore.Batch_Float32SumDense_getResult(self)

    def setResult(self, result):
        return _zscore.Batch_Float32SumDense_setResult(self, result)

    def clone(self):
        return _zscore.Batch_Float32SumDense_clone(self)

    def compute(self):
        return _zscore.Batch_Float32SumDense_compute(self)
Batch_Float32SumDense_swigregister = _zscore.Batch_Float32SumDense_swigregister
Batch_Float32SumDense_swigregister(Batch_Float32SumDense)

class Parameter_Float64DefaultDense(daal.algorithms.Parameter):
    r"""
This class is an alias of Parameter(fptype=float64, method=daal.algorithms.normalization.zscore.defaultDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter_Float64DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter_Float64DefaultDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _zscore.new_Parameter_Float64DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_setmethods__["moments"] = _zscore.Parameter_Float64DefaultDense_moments_set
    __swig_getmethods__["moments"] = _zscore.Parameter_Float64DefaultDense_moments_get
    if _newclass:
        moments = _swig_property(_zscore.Parameter_Float64DefaultDense_moments_get, _zscore.Parameter_Float64DefaultDense_moments_set)

    def check(self):
        return _zscore.Parameter_Float64DefaultDense_check(self)
    __swig_destroy__ = _zscore.delete_Parameter_Float64DefaultDense
    __del__ = lambda self: None
Parameter_Float64DefaultDense_swigregister = _zscore.Parameter_Float64DefaultDense_swigregister
Parameter_Float64DefaultDense_swigregister(Parameter_Float64DefaultDense)

class Parameter_Float64SumDense(daal.algorithms.Parameter):
    r"""
This class is an alias of Parameter(fptype=float64, method=daal.algorithms.normalization.zscore.sumDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter_Float64SumDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter_Float64SumDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _zscore.new_Parameter_Float64SumDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Parameter_Float64SumDense
    __del__ = lambda self: None
Parameter_Float64SumDense_swigregister = _zscore.Parameter_Float64SumDense_swigregister
Parameter_Float64SumDense_swigregister(Parameter_Float64SumDense)

class Parameter_Float32DefaultDense(daal.algorithms.Parameter):
    r"""
This class is an alias of Parameter(fptype=float32, method=daal.algorithms.normalization.zscore.defaultDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter_Float32DefaultDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter_Float32DefaultDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _zscore.new_Parameter_Float32DefaultDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_setmethods__["moments"] = _zscore.Parameter_Float32DefaultDense_moments_set
    __swig_getmethods__["moments"] = _zscore.Parameter_Float32DefaultDense_moments_get
    if _newclass:
        moments = _swig_property(_zscore.Parameter_Float32DefaultDense_moments_get, _zscore.Parameter_Float32DefaultDense_moments_set)

    def check(self):
        return _zscore.Parameter_Float32DefaultDense_check(self)
    __swig_destroy__ = _zscore.delete_Parameter_Float32DefaultDense
    __del__ = lambda self: None
Parameter_Float32DefaultDense_swigregister = _zscore.Parameter_Float32DefaultDense_swigregister
Parameter_Float32DefaultDense_swigregister(Parameter_Float32DefaultDense)

class Parameter_Float32SumDense(daal.algorithms.Parameter):
    r"""
This class is an alias of Parameter(fptype=float32, method=daal.algorithms.normalization.zscore.sumDense)
    """
    __swig_setmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Parameter_Float32SumDense, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.algorithms.Parameter]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Parameter_Float32SumDense, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _zscore.new_Parameter_Float32SumDense(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _zscore.delete_Parameter_Float32SumDense
    __del__ = lambda self: None
Parameter_Float32SumDense_swigregister = _zscore.Parameter_Float32SumDense_swigregister
Parameter_Float32SumDense_swigregister(Parameter_Float32SumDense)

from numpy import float64, float32, intc

class Parameter(object):
    r"""Factory class for different types of Parameter."""
    def __new__(cls,
                fptype,
                method,
                *args, **kwargs):
        if fptype == float64:
            if method == defaultDense:
                return Parameter_Float64DefaultDense(*args)
            if method == sumDense:
                return Parameter_Float64SumDense(*args)
        if fptype == float32:
            if method == defaultDense:
                return Parameter_Float32DefaultDense(*args)
            if method == sumDense:
                return Parameter_Float32SumDense(*args)

        raise RuntimeError("No appropriate constructor found for Parameter")

class Batch(object):
    r"""Factory class for different types of Batch."""
    def __new__(cls,
                *args, **kwargs):
        if 'fptype' not in kwargs or kwargs['fptype'] == float64:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float64DefaultDense(*args)
            if 'method' in kwargs and kwargs['method'] == sumDense:
                return Batch_Float64SumDense(*args)
        if 'fptype' in kwargs and kwargs['fptype'] == float32:
            if 'method' not in kwargs or kwargs['method'] == defaultDense:
                return Batch_Float32DefaultDense(*args)
            if 'method' in kwargs and kwargs['method'] == sumDense:
                return Batch_Float32SumDense(*args)

        raise RuntimeError("No appropriate constructor found for Batch")


# This file is compatible with both classic and new-style classes.


