# Copyright 2014-2017 Intel Corporation
# All Rights Reserved.
#
# If this  software was obtained  under the  Intel Simplified  Software License,
# the following terms apply:
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#
#
# If this  software  was obtained  under the  Apache License,  Version  2.0 (the
# "License"), the following terms apply:
#
# You may  not use this  file except  in compliance  with  the License.  You may
# obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0
#
#
# Unless  required  by   applicable  law  or  agreed  to  in  writing,  software
# distributed under the License  is distributed  on an  "AS IS"  BASIS,  WITHOUT
# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
# See the   License  for the   specific  language   governing   permissions  and
# limitations under the License.


from sys import version_info
if version_info >= (2, 6, 0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_services', [dirname(__file__)])
        except ImportError:
            import _services
            return _services
        if fp is not None:
            try:
                _mod = imp.load_module('_services', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _services = swig_import_helper()
    del swig_import_helper
else:
    import _services
del version_info
try:
    _swig_property = property
except NameError:
    pass  # Python < 2.2 doesn't have 'property'.


def _swig_setattr_nondynamic(self, class_type, name, value, static=1):
    if (name == "thisown"):
        return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name, None)
    if method:
        return method(self, value)
    if (not static):
        if _newclass:
            object.__setattr__(self, name, value)
        else:
            self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)


def _swig_setattr(self, class_type, name, value):
    return _swig_setattr_nondynamic(self, class_type, name, value, 0)


def _swig_getattr_nondynamic(self, class_type, name, static=1):
    if (name == "thisown"):
        return self.this.own()
    method = class_type.__swig_getmethods__.get(name, None)
    if method:
        return method(self)
    if (not static):
        return object.__getattr__(self, name)
    else:
        raise AttributeError(name)

def _swig_getattr(self, class_type, name):
    return _swig_getattr_nondynamic(self, class_type, name, 0)


def _swig_repr(self):
    try:
        strthis = "proxy of " + self.this.__repr__()
    except:
        strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object:
        pass
    _newclass = 0


import daal

_services.__INTEL_DAAL_BUILD_DATE_swigconstant(_services)
__INTEL_DAAL_BUILD_DATE = _services.__INTEL_DAAL_BUILD_DATE

_services.__INTEL_DAAL___swigconstant(_services)
__INTEL_DAAL__ = _services.__INTEL_DAAL__

_services.__INTEL_DAAL_MINOR___swigconstant(_services)
__INTEL_DAAL_MINOR__ = _services.__INTEL_DAAL_MINOR__

_services.__INTEL_DAAL_UPDATE___swigconstant(_services)
__INTEL_DAAL_UPDATE__ = _services.__INTEL_DAAL_UPDATE__

_services.INTEL_DAAL_VERSION_swigconstant(_services)
INTEL_DAAL_VERSION = _services.INTEL_DAAL_VERSION
class LibraryVersionInfo(daal.Base):
    __swig_setmethods__ = {}
    for _s in [daal.Base]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, LibraryVersionInfo, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.Base]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, LibraryVersionInfo, name)
    __repr__ = _swig_repr
    __swig_getmethods__["majorVersion"] = _services.LibraryVersionInfo_majorVersion_get
    if _newclass:
        majorVersion = _swig_property(_services.LibraryVersionInfo_majorVersion_get)
    __swig_getmethods__["minorVersion"] = _services.LibraryVersionInfo_minorVersion_get
    if _newclass:
        minorVersion = _swig_property(_services.LibraryVersionInfo_minorVersion_get)
    __swig_getmethods__["updateVersion"] = _services.LibraryVersionInfo_updateVersion_get
    if _newclass:
        updateVersion = _swig_property(_services.LibraryVersionInfo_updateVersion_get)
    __swig_getmethods__["productStatus"] = _services.LibraryVersionInfo_productStatus_get
    if _newclass:
        productStatus = _swig_property(_services.LibraryVersionInfo_productStatus_get)
    __swig_getmethods__["build"] = _services.LibraryVersionInfo_build_get
    if _newclass:
        build = _swig_property(_services.LibraryVersionInfo_build_get)
    __swig_getmethods__["build_rev"] = _services.LibraryVersionInfo_build_rev_get
    if _newclass:
        build_rev = _swig_property(_services.LibraryVersionInfo_build_rev_get)
    __swig_getmethods__["name"] = _services.LibraryVersionInfo_name_get
    if _newclass:
        name = _swig_property(_services.LibraryVersionInfo_name_get)
    __swig_getmethods__["processor"] = _services.LibraryVersionInfo_processor_get
    if _newclass:
        processor = _swig_property(_services.LibraryVersionInfo_processor_get)

    def __init__(self):
        this = _services.new_LibraryVersionInfo()
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _services.delete_LibraryVersionInfo
    __del__ = lambda self: None
LibraryVersionInfo_swigregister = _services.LibraryVersionInfo_swigregister
LibraryVersionInfo_swigregister(LibraryVersionInfo)


_services.NoErrorMessageDetailFound_swigconstant(_services)
NoErrorMessageDetailFound = _services.NoErrorMessageDetailFound

_services.Row_swigconstant(_services)
Row = _services.Row

_services.Column_swigconstant(_services)
Column = _services.Column

_services.Rank_swigconstant(_services)
Rank = _services.Rank

_services.StatisticsName_swigconstant(_services)
StatisticsName = _services.StatisticsName

_services.Method_swigconstant(_services)
Method = _services.Method

_services.Iteration_swigconstant(_services)
Iteration = _services.Iteration

_services.Component_swigconstant(_services)
Component = _services.Component

_services.Minor_swigconstant(_services)
Minor = _services.Minor

_services.ArgumentName_swigconstant(_services)
ArgumentName = _services.ArgumentName

_services.ElementInCollection_swigconstant(_services)
ElementInCollection = _services.ElementInCollection

_services.Dimension_swigconstant(_services)
Dimension = _services.Dimension

_services.ParameterName_swigconstant(_services)
ParameterName = _services.ParameterName

_services.OptionalInput_swigconstant(_services)
OptionalInput = _services.OptionalInput

_services.OptionalResult_swigconstant(_services)
OptionalResult = _services.OptionalResult

_services.Layer_swigconstant(_services)
Layer = _services.Layer

_services.SerializationTag_swigconstant(_services)
SerializationTag = _services.SerializationTag

_services.ExpectedValue_swigconstant(_services)
ExpectedValue = _services.ExpectedValue

_services.ActualValue_swigconstant(_services)
ActualValue = _services.ActualValue

_services.ErrorMethodNotSupported_swigconstant(_services)
ErrorMethodNotSupported = _services.ErrorMethodNotSupported

_services.ErrorIncorrectNumberOfFeatures_swigconstant(_services)
ErrorIncorrectNumberOfFeatures = _services.ErrorIncorrectNumberOfFeatures

_services.ErrorIncorrectNumberOfObservations_swigconstant(_services)
ErrorIncorrectNumberOfObservations = _services.ErrorIncorrectNumberOfObservations

_services.ErrorIncorrectSizeOfArray_swigconstant(_services)
ErrorIncorrectSizeOfArray = _services.ErrorIncorrectSizeOfArray

_services.ErrorNullParameterNotSupported_swigconstant(_services)
ErrorNullParameterNotSupported = _services.ErrorNullParameterNotSupported

_services.ErrorIncorrectNumberOfArguments_swigconstant(_services)
ErrorIncorrectNumberOfArguments = _services.ErrorIncorrectNumberOfArguments

_services.ErrorIncorrectInputNumericTable_swigconstant(_services)
ErrorIncorrectInputNumericTable = _services.ErrorIncorrectInputNumericTable

_services.ErrorEmptyInputNumericTable_swigconstant(_services)
ErrorEmptyInputNumericTable = _services.ErrorEmptyInputNumericTable

_services.ErrorIncorrectDataRange_swigconstant(_services)
ErrorIncorrectDataRange = _services.ErrorIncorrectDataRange

_services.ErrorPrecomputedStatisticsIndexOutOfRange_swigconstant(_services)
ErrorPrecomputedStatisticsIndexOutOfRange = _services.ErrorPrecomputedStatisticsIndexOutOfRange

_services.ErrorIncorrectNumberOfInputNumericTables_swigconstant(_services)
ErrorIncorrectNumberOfInputNumericTables = _services.ErrorIncorrectNumberOfInputNumericTables

_services.ErrorIncorrectNumberOfOutputNumericTables_swigconstant(_services)
ErrorIncorrectNumberOfOutputNumericTables = _services.ErrorIncorrectNumberOfOutputNumericTables

_services.ErrorNullInputNumericTable_swigconstant(_services)
ErrorNullInputNumericTable = _services.ErrorNullInputNumericTable

_services.ErrorNullOutputNumericTable_swigconstant(_services)
ErrorNullOutputNumericTable = _services.ErrorNullOutputNumericTable

_services.ErrorNullModel_swigconstant(_services)
ErrorNullModel = _services.ErrorNullModel

_services.ErrorInconsistentNumberOfRows_swigconstant(_services)
ErrorInconsistentNumberOfRows = _services.ErrorInconsistentNumberOfRows

_services.ErrorIncorrectSizeOfInputNumericTable_swigconstant(_services)
ErrorIncorrectSizeOfInputNumericTable = _services.ErrorIncorrectSizeOfInputNumericTable

_services.ErrorIncorrectSizeOfOutputNumericTable_swigconstant(_services)
ErrorIncorrectSizeOfOutputNumericTable = _services.ErrorIncorrectSizeOfOutputNumericTable

_services.ErrorIncorrectNumberOfRowsInInputNumericTable_swigconstant(_services)
ErrorIncorrectNumberOfRowsInInputNumericTable = _services.ErrorIncorrectNumberOfRowsInInputNumericTable

_services.ErrorIncorrectNumberOfColumnsInInputNumericTable_swigconstant(_services)
ErrorIncorrectNumberOfColumnsInInputNumericTable = _services.ErrorIncorrectNumberOfColumnsInInputNumericTable

_services.ErrorIncorrectNumberOfRowsInOutputNumericTable_swigconstant(_services)
ErrorIncorrectNumberOfRowsInOutputNumericTable = _services.ErrorIncorrectNumberOfRowsInOutputNumericTable

_services.ErrorIncorrectNumberOfColumnsInOutputNumericTable_swigconstant(_services)
ErrorIncorrectNumberOfColumnsInOutputNumericTable = _services.ErrorIncorrectNumberOfColumnsInOutputNumericTable

_services.ErrorIncorrectTypeOfInputNumericTable_swigconstant(_services)
ErrorIncorrectTypeOfInputNumericTable = _services.ErrorIncorrectTypeOfInputNumericTable

_services.ErrorIncorrectTypeOfOutputNumericTable_swigconstant(_services)
ErrorIncorrectTypeOfOutputNumericTable = _services.ErrorIncorrectTypeOfOutputNumericTable

_services.ErrorIncorrectNumberOfElementsInInputCollection_swigconstant(_services)
ErrorIncorrectNumberOfElementsInInputCollection = _services.ErrorIncorrectNumberOfElementsInInputCollection

_services.ErrorIncorrectNumberOfElementsInResultCollection_swigconstant(_services)
ErrorIncorrectNumberOfElementsInResultCollection = _services.ErrorIncorrectNumberOfElementsInResultCollection

_services.ErrorNullInput_swigconstant(_services)
ErrorNullInput = _services.ErrorNullInput

_services.ErrorNullResult_swigconstant(_services)
ErrorNullResult = _services.ErrorNullResult

_services.ErrorIncorrectParameter_swigconstant(_services)
ErrorIncorrectParameter = _services.ErrorIncorrectParameter

_services.ErrorModelNotFullInitialized_swigconstant(_services)
ErrorModelNotFullInitialized = _services.ErrorModelNotFullInitialized

_services.ErrorInconsistentNumberOfColumns_swigconstant(_services)
ErrorInconsistentNumberOfColumns = _services.ErrorInconsistentNumberOfColumns

_services.ErrorIncorrectIndex_swigconstant(_services)
ErrorIncorrectIndex = _services.ErrorIncorrectIndex

_services.ErrorDataArchiveInternal_swigconstant(_services)
ErrorDataArchiveInternal = _services.ErrorDataArchiveInternal

_services.ErrorNullPartialModel_swigconstant(_services)
ErrorNullPartialModel = _services.ErrorNullPartialModel

_services.ErrorNullInputDataCollection_swigconstant(_services)
ErrorNullInputDataCollection = _services.ErrorNullInputDataCollection

_services.ErrorNullOutputDataCollection_swigconstant(_services)
ErrorNullOutputDataCollection = _services.ErrorNullOutputDataCollection

_services.ErrorNullPartialResult_swigconstant(_services)
ErrorNullPartialResult = _services.ErrorNullPartialResult

_services.ErrorIncorrectNumberOfInputNumericTensors_swigconstant(_services)
ErrorIncorrectNumberOfInputNumericTensors = _services.ErrorIncorrectNumberOfInputNumericTensors

_services.ErrorIncorrectNumberOfOutputNumericTensors_swigconstant(_services)
ErrorIncorrectNumberOfOutputNumericTensors = _services.ErrorIncorrectNumberOfOutputNumericTensors

_services.ErrorNullTensor_swigconstant(_services)
ErrorNullTensor = _services.ErrorNullTensor

_services.ErrorIncorrectNumberOfDimensionsInTensor_swigconstant(_services)
ErrorIncorrectNumberOfDimensionsInTensor = _services.ErrorIncorrectNumberOfDimensionsInTensor

_services.ErrorIncorrectSizeOfDimensionInTensor_swigconstant(_services)
ErrorIncorrectSizeOfDimensionInTensor = _services.ErrorIncorrectSizeOfDimensionInTensor

_services.ErrorNullLayerData_swigconstant(_services)
ErrorNullLayerData = _services.ErrorNullLayerData

_services.ErrorIncorrectSizeOfLayerData_swigconstant(_services)
ErrorIncorrectSizeOfLayerData = _services.ErrorIncorrectSizeOfLayerData

_services.ErrorNullNumericTable_swigconstant(_services)
ErrorNullNumericTable = _services.ErrorNullNumericTable

_services.ErrorIncorrectNumberOfColumns_swigconstant(_services)
ErrorIncorrectNumberOfColumns = _services.ErrorIncorrectNumberOfColumns

_services.ErrorIncorrectNumberOfRows_swigconstant(_services)
ErrorIncorrectNumberOfRows = _services.ErrorIncorrectNumberOfRows

_services.ErrorIncorrectTypeOfNumericTable_swigconstant(_services)
ErrorIncorrectTypeOfNumericTable = _services.ErrorIncorrectTypeOfNumericTable

_services.ErrorUnsupportedCSRIndexing_swigconstant(_services)
ErrorUnsupportedCSRIndexing = _services.ErrorUnsupportedCSRIndexing

_services.ErrorSignificanceLevel_swigconstant(_services)
ErrorSignificanceLevel = _services.ErrorSignificanceLevel

_services.ErrorAccuracyThreshold_swigconstant(_services)
ErrorAccuracyThreshold = _services.ErrorAccuracyThreshold

_services.ErrorIncorrectNumberOfBetas_swigconstant(_services)
ErrorIncorrectNumberOfBetas = _services.ErrorIncorrectNumberOfBetas

_services.ErrorIncorrectNumberOfBetasInReducedModel_swigconstant(_services)
ErrorIncorrectNumberOfBetasInReducedModel = _services.ErrorIncorrectNumberOfBetasInReducedModel

_services.ErrorNumericTableIsNotSquare_swigconstant(_services)
ErrorNumericTableIsNotSquare = _services.ErrorNumericTableIsNotSquare

_services.ErrorNullAuxiliaryAlgorithm_swigconstant(_services)
ErrorNullAuxiliaryAlgorithm = _services.ErrorNullAuxiliaryAlgorithm

_services.ErrorNullInitializationProcedure_swigconstant(_services)
ErrorNullInitializationProcedure = _services.ErrorNullInitializationProcedure

_services.ErrorNullAuxiliaryDataCollection_swigconstant(_services)
ErrorNullAuxiliaryDataCollection = _services.ErrorNullAuxiliaryDataCollection

_services.ErrorEmptyAuxiliaryDataCollection_swigconstant(_services)
ErrorEmptyAuxiliaryDataCollection = _services.ErrorEmptyAuxiliaryDataCollection

_services.ErrorIncorrectElementInCollection_swigconstant(_services)
ErrorIncorrectElementInCollection = _services.ErrorIncorrectElementInCollection

_services.ErrorNullPartialResultDataCollection_swigconstant(_services)
ErrorNullPartialResultDataCollection = _services.ErrorNullPartialResultDataCollection

_services.ErrorIncorrectElementInPartialResultCollection_swigconstant(_services)
ErrorIncorrectElementInPartialResultCollection = _services.ErrorIncorrectElementInPartialResultCollection

_services.ErrorIncorrectElementInNumericTableCollection_swigconstant(_services)
ErrorIncorrectElementInNumericTableCollection = _services.ErrorIncorrectElementInNumericTableCollection

_services.ErrorNullOptionalResult_swigconstant(_services)
ErrorNullOptionalResult = _services.ErrorNullOptionalResult

_services.ErrorIncorrectOptionalResult_swigconstant(_services)
ErrorIncorrectOptionalResult = _services.ErrorIncorrectOptionalResult

_services.ErrorIncorrectOptionalInput_swigconstant(_services)
ErrorIncorrectOptionalInput = _services.ErrorIncorrectOptionalInput

_services.ErrorIncorrectNumberOfPartialClusters_swigconstant(_services)
ErrorIncorrectNumberOfPartialClusters = _services.ErrorIncorrectNumberOfPartialClusters

_services.ErrorIncorrectTotalNumberOfPartialClusters_swigconstant(_services)
ErrorIncorrectTotalNumberOfPartialClusters = _services.ErrorIncorrectTotalNumberOfPartialClusters

_services.ErrorIncorrectDataCollectionSize_swigconstant(_services)
ErrorIncorrectDataCollectionSize = _services.ErrorIncorrectDataCollectionSize

_services.ErrorIncorrectValueInTheNumericTable_swigconstant(_services)
ErrorIncorrectValueInTheNumericTable = _services.ErrorIncorrectValueInTheNumericTable

_services.ErrorIncorrectItemInDataCollection_swigconstant(_services)
ErrorIncorrectItemInDataCollection = _services.ErrorIncorrectItemInDataCollection

_services.ErrorNullPtr_swigconstant(_services)
ErrorNullPtr = _services.ErrorNullPtr

_services.ErrorUndefinedFeature_swigconstant(_services)
ErrorUndefinedFeature = _services.ErrorUndefinedFeature

_services.ErrorCpuNotSupported_swigconstant(_services)
ErrorCpuNotSupported = _services.ErrorCpuNotSupported

_services.ErrorMemoryAllocationFailed_swigconstant(_services)
ErrorMemoryAllocationFailed = _services.ErrorMemoryAllocationFailed

_services.ErrorEmptyDataBlock_swigconstant(_services)
ErrorEmptyDataBlock = _services.ErrorEmptyDataBlock

_services.ErrorIncorrectCombinationOfComputationModeAndStep_swigconstant(_services)
ErrorIncorrectCombinationOfComputationModeAndStep = _services.ErrorIncorrectCombinationOfComputationModeAndStep

_services.ErrorDictionaryAlreadyAvailable_swigconstant(_services)
ErrorDictionaryAlreadyAvailable = _services.ErrorDictionaryAlreadyAvailable

_services.ErrorDictionaryNotAvailable_swigconstant(_services)
ErrorDictionaryNotAvailable = _services.ErrorDictionaryNotAvailable

_services.ErrorNumericTableNotAvailable_swigconstant(_services)
ErrorNumericTableNotAvailable = _services.ErrorNumericTableNotAvailable

_services.ErrorNumericTableAlreadyAllocated_swigconstant(_services)
ErrorNumericTableAlreadyAllocated = _services.ErrorNumericTableAlreadyAllocated

_services.ErrorNumericTableNotAllocated_swigconstant(_services)
ErrorNumericTableNotAllocated = _services.ErrorNumericTableNotAllocated

_services.ErrorPrecomputedSumNotAvailable_swigconstant(_services)
ErrorPrecomputedSumNotAvailable = _services.ErrorPrecomputedSumNotAvailable

_services.ErrorPrecomputedMinNotAvailable_swigconstant(_services)
ErrorPrecomputedMinNotAvailable = _services.ErrorPrecomputedMinNotAvailable

_services.ErrorPrecomputedMaxNotAvailable_swigconstant(_services)
ErrorPrecomputedMaxNotAvailable = _services.ErrorPrecomputedMaxNotAvailable

_services.ErrorServiceMicroTableInternal_swigconstant(_services)
ErrorServiceMicroTableInternal = _services.ErrorServiceMicroTableInternal

_services.ErrorEmptyCSRNumericTable_swigconstant(_services)
ErrorEmptyCSRNumericTable = _services.ErrorEmptyCSRNumericTable

_services.ErrorEmptyHomogenNumericTable_swigconstant(_services)
ErrorEmptyHomogenNumericTable = _services.ErrorEmptyHomogenNumericTable

_services.ErrorSourceDataNotAvailable_swigconstant(_services)
ErrorSourceDataNotAvailable = _services.ErrorSourceDataNotAvailable

_services.ErrorEmptyDataSource_swigconstant(_services)
ErrorEmptyDataSource = _services.ErrorEmptyDataSource

_services.ErrorIncorrectClassLabels_swigconstant(_services)
ErrorIncorrectClassLabels = _services.ErrorIncorrectClassLabels

_services.ErrorIncorrectSizeOfModel_swigconstant(_services)
ErrorIncorrectSizeOfModel = _services.ErrorIncorrectSizeOfModel

_services.ErrorIncorrectTypeOfModel_swigconstant(_services)
ErrorIncorrectTypeOfModel = _services.ErrorIncorrectTypeOfModel

_services.ErrorIncorrectErrorcodeFromGenerator_swigconstant(_services)
ErrorIncorrectErrorcodeFromGenerator = _services.ErrorIncorrectErrorcodeFromGenerator

_services.ErrorInputSigmaMatrixHasNonPositiveMinor_swigconstant(_services)
ErrorInputSigmaMatrixHasNonPositiveMinor = _services.ErrorInputSigmaMatrixHasNonPositiveMinor

_services.ErrorInputSigmaMatrixHasIllegalValue_swigconstant(_services)
ErrorInputSigmaMatrixHasIllegalValue = _services.ErrorInputSigmaMatrixHasIllegalValue

_services.ErrorIncorrectInternalFunctionParameter_swigconstant(_services)
ErrorIncorrectInternalFunctionParameter = _services.ErrorIncorrectInternalFunctionParameter

_services.ErrorAprioriIncorrectItemsetTableSize_swigconstant(_services)
ErrorAprioriIncorrectItemsetTableSize = _services.ErrorAprioriIncorrectItemsetTableSize

_services.ErrorAprioriIncorrectSupportTableSize_swigconstant(_services)
ErrorAprioriIncorrectSupportTableSize = _services.ErrorAprioriIncorrectSupportTableSize

_services.ErrorAprioriIncorrectLeftRuleTableSize_swigconstant(_services)
ErrorAprioriIncorrectLeftRuleTableSize = _services.ErrorAprioriIncorrectLeftRuleTableSize

_services.ErrorAprioriIncorrectRightRuleTableSize_swigconstant(_services)
ErrorAprioriIncorrectRightRuleTableSize = _services.ErrorAprioriIncorrectRightRuleTableSize

_services.ErrorAprioriIncorrectConfidenceTableSize_swigconstant(_services)
ErrorAprioriIncorrectConfidenceTableSize = _services.ErrorAprioriIncorrectConfidenceTableSize

_services.ErrorAprioriIncorrectInputData_swigconstant(_services)
ErrorAprioriIncorrectInputData = _services.ErrorAprioriIncorrectInputData

_services.ErrorCholeskyInternal_swigconstant(_services)
ErrorCholeskyInternal = _services.ErrorCholeskyInternal

_services.ErrorInputMatrixHasNonPositiveMinor_swigconstant(_services)
ErrorInputMatrixHasNonPositiveMinor = _services.ErrorInputMatrixHasNonPositiveMinor

_services.ErrorCovarianceInternal_swigconstant(_services)
ErrorCovarianceInternal = _services.ErrorCovarianceInternal

_services.ErrorEMMatrixInverse_swigconstant(_services)
ErrorEMMatrixInverse = _services.ErrorEMMatrixInverse

_services.ErrorEMIncorrectToleranceToConverge_swigconstant(_services)
ErrorEMIncorrectToleranceToConverge = _services.ErrorEMIncorrectToleranceToConverge

_services.ErrorEMIllConditionedCovarianceMatrix_swigconstant(_services)
ErrorEMIllConditionedCovarianceMatrix = _services.ErrorEMIllConditionedCovarianceMatrix

_services.ErrorEMIncorrectMaxNumberOfIterations_swigconstant(_services)
ErrorEMIncorrectMaxNumberOfIterations = _services.ErrorEMIncorrectMaxNumberOfIterations

_services.ErrorEMNegativeDefinedCovarianceMartix_swigconstant(_services)
ErrorEMNegativeDefinedCovarianceMartix = _services.ErrorEMNegativeDefinedCovarianceMartix

_services.ErrorEMEmptyComponent_swigconstant(_services)
ErrorEMEmptyComponent = _services.ErrorEMEmptyComponent

_services.ErrorEMCovariance_swigconstant(_services)
ErrorEMCovariance = _services.ErrorEMCovariance

_services.ErrorEMIncorrectNumberOfComponents_swigconstant(_services)
ErrorEMIncorrectNumberOfComponents = _services.ErrorEMIncorrectNumberOfComponents

_services.ErrorEMInitNoTrialConverges_swigconstant(_services)
ErrorEMInitNoTrialConverges = _services.ErrorEMInitNoTrialConverges

_services.ErrorEMInitIncorrectToleranceToConverge_swigconstant(_services)
ErrorEMInitIncorrectToleranceToConverge = _services.ErrorEMInitIncorrectToleranceToConverge

_services.ErrorEMInitIncorrectDepthNumberIterations_swigconstant(_services)
ErrorEMInitIncorrectDepthNumberIterations = _services.ErrorEMInitIncorrectDepthNumberIterations

_services.ErrorEMInitIncorrectNumberOfTrials_swigconstant(_services)
ErrorEMInitIncorrectNumberOfTrials = _services.ErrorEMInitIncorrectNumberOfTrials

_services.ErrorEMInitIncorrectNumberOfComponents_swigconstant(_services)
ErrorEMInitIncorrectNumberOfComponents = _services.ErrorEMInitIncorrectNumberOfComponents

_services.ErrorEMInitInconsistentNumberOfComponents_swigconstant(_services)
ErrorEMInitInconsistentNumberOfComponents = _services.ErrorEMInitInconsistentNumberOfComponents

_services.ErrorVarianceComputation_swigconstant(_services)
ErrorVarianceComputation = _services.ErrorVarianceComputation

_services.ErrorLinearRegressionInternal_swigconstant(_services)
ErrorLinearRegressionInternal = _services.ErrorLinearRegressionInternal

_services.ErrorNormEqSystemSolutionFailed_swigconstant(_services)
ErrorNormEqSystemSolutionFailed = _services.ErrorNormEqSystemSolutionFailed

_services.ErrorLinRegXtXInvFailed_swigconstant(_services)
ErrorLinRegXtXInvFailed = _services.ErrorLinRegXtXInvFailed

_services.ErrorLowOrderMomentsInternal_swigconstant(_services)
ErrorLowOrderMomentsInternal = _services.ErrorLowOrderMomentsInternal

_services.ErrorIncorrectNumberOfClasses_swigconstant(_services)
ErrorIncorrectNumberOfClasses = _services.ErrorIncorrectNumberOfClasses

_services.ErrorMultiClassNullTwoClassTraining_swigconstant(_services)
ErrorMultiClassNullTwoClassTraining = _services.ErrorMultiClassNullTwoClassTraining

_services.ErrorMultiClassFailedToTrainTwoClassClassifier_swigconstant(_services)
ErrorMultiClassFailedToTrainTwoClassClassifier = _services.ErrorMultiClassFailedToTrainTwoClassClassifier

_services.ErrorMultiClassFailedToComputeTwoClassPrediction_swigconstant(_services)
ErrorMultiClassFailedToComputeTwoClassPrediction = _services.ErrorMultiClassFailedToComputeTwoClassPrediction

_services.ErrorOutlierDetectionInternal_swigconstant(_services)
ErrorOutlierDetectionInternal = _services.ErrorOutlierDetectionInternal

_services.ErrorPCAFailedToComputeCorrelationEigenvalues_swigconstant(_services)
ErrorPCAFailedToComputeCorrelationEigenvalues = _services.ErrorPCAFailedToComputeCorrelationEigenvalues

_services.ErrorPCACorrelationInputDataTypeSupportsOfflineModeOnly_swigconstant(_services)
ErrorPCACorrelationInputDataTypeSupportsOfflineModeOnly = _services.ErrorPCACorrelationInputDataTypeSupportsOfflineModeOnly

_services.ErrorIncorrectCrossProductTableSize_swigconstant(_services)
ErrorIncorrectCrossProductTableSize = _services.ErrorIncorrectCrossProductTableSize

_services.ErrorCrossProductTableIsNotSquare_swigconstant(_services)
ErrorCrossProductTableIsNotSquare = _services.ErrorCrossProductTableIsNotSquare

_services.ErrorInputCorrelationNotSupportedInOnlineAndDistributed_swigconstant(_services)
ErrorInputCorrelationNotSupportedInOnlineAndDistributed = _services.ErrorInputCorrelationNotSupportedInOnlineAndDistributed

_services.ErrorQRInternal_swigconstant(_services)
ErrorQRInternal = _services.ErrorQRInternal

_services.ErrorQrIthParamIllegalValue_swigconstant(_services)
ErrorQrIthParamIllegalValue = _services.ErrorQrIthParamIllegalValue

_services.ErrorQrXBDSQRDidNotConverge_swigconstant(_services)
ErrorQrXBDSQRDidNotConverge = _services.ErrorQrXBDSQRDidNotConverge

_services.ErrorStumpIncorrectSplitFeature_swigconstant(_services)
ErrorStumpIncorrectSplitFeature = _services.ErrorStumpIncorrectSplitFeature

_services.ErrorStumpInvalidInputCategoricalData_swigconstant(_services)
ErrorStumpInvalidInputCategoricalData = _services.ErrorStumpInvalidInputCategoricalData

_services.ErrorSvdIthParamIllegalValue_swigconstant(_services)
ErrorSvdIthParamIllegalValue = _services.ErrorSvdIthParamIllegalValue

_services.ErrorSvdXBDSQRDidNotConverge_swigconstant(_services)
ErrorSvdXBDSQRDidNotConverge = _services.ErrorSvdXBDSQRDidNotConverge

_services.ErrorLCNinnerConvolution_swigconstant(_services)
ErrorLCNinnerConvolution = _services.ErrorLCNinnerConvolution

_services.ErrorSVMPredictKernerFunctionCall_swigconstant(_services)
ErrorSVMPredictKernerFunctionCall = _services.ErrorSVMPredictKernerFunctionCall

_services.ErrorCompressionNullInputStream_swigconstant(_services)
ErrorCompressionNullInputStream = _services.ErrorCompressionNullInputStream

_services.ErrorCompressionNullOutputStream_swigconstant(_services)
ErrorCompressionNullOutputStream = _services.ErrorCompressionNullOutputStream

_services.ErrorCompressionEmptyInputStream_swigconstant(_services)
ErrorCompressionEmptyInputStream = _services.ErrorCompressionEmptyInputStream

_services.ErrorCompressionEmptyOutputStream_swigconstant(_services)
ErrorCompressionEmptyOutputStream = _services.ErrorCompressionEmptyOutputStream

_services.ErrorZlibInternal_swigconstant(_services)
ErrorZlibInternal = _services.ErrorZlibInternal

_services.ErrorZlibDataFormat_swigconstant(_services)
ErrorZlibDataFormat = _services.ErrorZlibDataFormat

_services.ErrorZlibParameters_swigconstant(_services)
ErrorZlibParameters = _services.ErrorZlibParameters

_services.ErrorZlibMemoryAllocationFailed_swigconstant(_services)
ErrorZlibMemoryAllocationFailed = _services.ErrorZlibMemoryAllocationFailed

_services.ErrorZlibNeedDictionary_swigconstant(_services)
ErrorZlibNeedDictionary = _services.ErrorZlibNeedDictionary

_services.ErrorBzip2Internal_swigconstant(_services)
ErrorBzip2Internal = _services.ErrorBzip2Internal

_services.ErrorBzip2DataFormat_swigconstant(_services)
ErrorBzip2DataFormat = _services.ErrorBzip2DataFormat

_services.ErrorBzip2Parameters_swigconstant(_services)
ErrorBzip2Parameters = _services.ErrorBzip2Parameters

_services.ErrorBzip2MemoryAllocationFailed_swigconstant(_services)
ErrorBzip2MemoryAllocationFailed = _services.ErrorBzip2MemoryAllocationFailed

_services.ErrorLzoInternal_swigconstant(_services)
ErrorLzoInternal = _services.ErrorLzoInternal

_services.ErrorLzoOutputStreamSizeIsNotEnough_swigconstant(_services)
ErrorLzoOutputStreamSizeIsNotEnough = _services.ErrorLzoOutputStreamSizeIsNotEnough

_services.ErrorLzoDataFormat_swigconstant(_services)
ErrorLzoDataFormat = _services.ErrorLzoDataFormat

_services.ErrorLzoDataFormatLessThenHeader_swigconstant(_services)
ErrorLzoDataFormatLessThenHeader = _services.ErrorLzoDataFormatLessThenHeader

_services.ErrorLzoDataFormatNotFullBlock_swigconstant(_services)
ErrorLzoDataFormatNotFullBlock = _services.ErrorLzoDataFormatNotFullBlock

_services.ErrorRleInternal_swigconstant(_services)
ErrorRleInternal = _services.ErrorRleInternal

_services.ErrorRleOutputStreamSizeIsNotEnough_swigconstant(_services)
ErrorRleOutputStreamSizeIsNotEnough = _services.ErrorRleOutputStreamSizeIsNotEnough

_services.ErrorRleDataFormat_swigconstant(_services)
ErrorRleDataFormat = _services.ErrorRleDataFormat

_services.ErrorRleDataFormatLessThenHeader_swigconstant(_services)
ErrorRleDataFormatLessThenHeader = _services.ErrorRleDataFormatLessThenHeader

_services.ErrorRleDataFormatNotFullBlock_swigconstant(_services)
ErrorRleDataFormatNotFullBlock = _services.ErrorRleDataFormatNotFullBlock

_services.ErrorLowerBoundGreaterThanOrEqualToUpperBound_swigconstant(_services)
ErrorLowerBoundGreaterThanOrEqualToUpperBound = _services.ErrorLowerBoundGreaterThanOrEqualToUpperBound

_services.ErrorQuantileOrderValueIsInvalid_swigconstant(_services)
ErrorQuantileOrderValueIsInvalid = _services.ErrorQuantileOrderValueIsInvalid

_services.ErrorQuantilesInternal_swigconstant(_services)
ErrorQuantilesInternal = _services.ErrorQuantilesInternal

_services.ErrorALSInternal_swigconstant(_services)
ErrorALSInternal = _services.ErrorALSInternal

_services.ErrorALSInconsistentSparseDataBlocks_swigconstant(_services)
ErrorALSInconsistentSparseDataBlocks = _services.ErrorALSInconsistentSparseDataBlocks

_services.ErrorSorting_swigconstant(_services)
ErrorSorting = _services.ErrorSorting

_services.ErrorNegativeLearningRate_swigconstant(_services)
ErrorNegativeLearningRate = _services.ErrorNegativeLearningRate

_services.ErrorMeanAndStandardDeviationComputing_swigconstant(_services)
ErrorMeanAndStandardDeviationComputing = _services.ErrorMeanAndStandardDeviationComputing

_services.ErrorNullVariance_swigconstant(_services)
ErrorNullVariance = _services.ErrorNullVariance

_services.ErrorMinAndMaxComputing_swigconstant(_services)
ErrorMinAndMaxComputing = _services.ErrorMinAndMaxComputing

_services.ErrorZeroNumberOfTerms_swigconstant(_services)
ErrorZeroNumberOfTerms = _services.ErrorZeroNumberOfTerms

_services.ErrorConvolutionInternal_swigconstant(_services)
ErrorConvolutionInternal = _services.ErrorConvolutionInternal

_services.ErrorRidgeRegressionInternal_swigconstant(_services)
ErrorRidgeRegressionInternal = _services.ErrorRidgeRegressionInternal

_services.ErrorRidgeRegressionNormEqSystemSolutionFailed_swigconstant(_services)
ErrorRidgeRegressionNormEqSystemSolutionFailed = _services.ErrorRidgeRegressionNormEqSystemSolutionFailed

_services.ErrorRidgeRegressionInvertFailed_swigconstant(_services)
ErrorRidgeRegressionInvertFailed = _services.ErrorRidgeRegressionInvertFailed

_services.ErrorInconsistenceModelAndBatchSizeInParameter_swigconstant(_services)
ErrorInconsistenceModelAndBatchSizeInParameter = _services.ErrorInconsistenceModelAndBatchSizeInParameter

_services.ErrorNeuralNetworkLayerCall_swigconstant(_services)
ErrorNeuralNetworkLayerCall = _services.ErrorNeuralNetworkLayerCall

_services.ErrorSplitLayerBackward_swigconstant(_services)
ErrorSplitLayerBackward = _services.ErrorSplitLayerBackward

_services.ErrorPivotedQRInternal_swigconstant(_services)
ErrorPivotedQRInternal = _services.ErrorPivotedQRInternal

_services.ErrorDFBootstrapVarImportanceIncompatible_swigconstant(_services)
ErrorDFBootstrapVarImportanceIncompatible = _services.ErrorDFBootstrapVarImportanceIncompatible

_services.ErrorDFBootstrapOOBIncompatible_swigconstant(_services)
ErrorDFBootstrapOOBIncompatible = _services.ErrorDFBootstrapOOBIncompatible

_services.ErrorUserAllocatedMemory_swigconstant(_services)
ErrorUserAllocatedMemory = _services.ErrorUserAllocatedMemory

_services.ErrorDataSourseNotAvailable_swigconstant(_services)
ErrorDataSourseNotAvailable = _services.ErrorDataSourseNotAvailable

_services.ErrorHandlesSQL_swigconstant(_services)
ErrorHandlesSQL = _services.ErrorHandlesSQL

_services.ErrorODBC_swigconstant(_services)
ErrorODBC = _services.ErrorODBC

_services.ErrorSQLstmtHandle_swigconstant(_services)
ErrorSQLstmtHandle = _services.ErrorSQLstmtHandle

_services.ErrorOnFileOpen_swigconstant(_services)
ErrorOnFileOpen = _services.ErrorOnFileOpen

_services.ErrorOnFileRead_swigconstant(_services)
ErrorOnFileRead = _services.ErrorOnFileRead

_services.ErrorKDBNoConnection_swigconstant(_services)
ErrorKDBNoConnection = _services.ErrorKDBNoConnection

_services.ErrorKDBWrongCredentials_swigconstant(_services)
ErrorKDBWrongCredentials = _services.ErrorKDBWrongCredentials

_services.ErrorKDBNetworkError_swigconstant(_services)
ErrorKDBNetworkError = _services.ErrorKDBNetworkError

_services.ErrorKDBServerError_swigconstant(_services)
ErrorKDBServerError = _services.ErrorKDBServerError

_services.ErrorKDBTypeUnsupported_swigconstant(_services)
ErrorKDBTypeUnsupported = _services.ErrorKDBTypeUnsupported

_services.ErrorKDBWrongTypeOfOutput_swigconstant(_services)
ErrorKDBWrongTypeOfOutput = _services.ErrorKDBWrongTypeOfOutput

_services.ErrorIncorrectEngineParameter_swigconstant(_services)
ErrorIncorrectEngineParameter = _services.ErrorIncorrectEngineParameter

_services.ErrorObjectDoesNotSupportSerialization_swigconstant(_services)
ErrorObjectDoesNotSupportSerialization = _services.ErrorObjectDoesNotSupportSerialization

_services.ErrorCouldntAttachCurrentThreadToJavaVM_swigconstant(_services)
ErrorCouldntAttachCurrentThreadToJavaVM = _services.ErrorCouldntAttachCurrentThreadToJavaVM

_services.ErrorCouldntCreateGlobalReferenceToJavaObject_swigconstant(_services)
ErrorCouldntCreateGlobalReferenceToJavaObject = _services.ErrorCouldntCreateGlobalReferenceToJavaObject

_services.ErrorCouldntFindJavaMethod_swigconstant(_services)
ErrorCouldntFindJavaMethod = _services.ErrorCouldntFindJavaMethod

_services.ErrorCouldntFindClassForJavaObject_swigconstant(_services)
ErrorCouldntFindClassForJavaObject = _services.ErrorCouldntFindClassForJavaObject

_services.UnknownError_swigconstant(_services)
UnknownError = _services.UnknownError

_services.NoErrorMessageFound_swigconstant(_services)
NoErrorMessageFound = _services.NoErrorMessageFound
class Exception(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Exception, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Exception, name)
    __repr__ = _swig_repr

    def __init__(self, description):
        this = _services.new_Exception(description)
        try:
            self.this.append(this)
        except:
            self.this = this

    def what(self):
        return _services.Exception_what(self)
    __swig_destroy__ = _services.delete_Exception
    __del__ = lambda self: None
    __swig_getmethods__["getException"] = lambda x: _services.Exception_getException
    if _newclass:
        getException = staticmethod(_services.Exception_getException)
Exception_swigregister = _services.Exception_swigregister
Exception_swigregister(Exception)

def Exception_getException(*args):
    return _services.Exception_getException(*args)
Exception_getException = _services.Exception_getException

class Error(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Error, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Error, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _services.new_Error(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _services.delete_Error
    __del__ = lambda self: None

    def id(self):
        return _services.Error_id(self)

    def setId(self, id):
        return _services.Error_setId(self, id)

    def description(self):
        return _services.Error_description(self)

    def addIntDetail(self, id, value):
        return _services.Error_addIntDetail(self, id, value)

    def addDoubleDetail(self, id, value):
        return _services.Error_addDoubleDetail(self, id, value)

    def addStringDetail(self, id, value):
        return _services.Error_addStringDetail(self, id, value)

    def details(self):
        return _services.Error_details(self)
    __swig_getmethods__["create"] = lambda x: _services.Error_create
    if _newclass:
        create = staticmethod(_services.Error_create)
Error_swigregister = _services.Error_swigregister
Error_swigregister(Error)

def Error_create(*args):
    return _services.Error_create(*args)
Error_create = _services.Error_create

class KernelErrorCollection(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, KernelErrorCollection, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, KernelErrorCollection, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _services.new_KernelErrorCollection(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def add(self, *args):
        return _services.KernelErrorCollection_add(self, *args)

    def isEmpty(self):
        return _services.KernelErrorCollection_isEmpty(self)

    def size(self):
        return _services.KernelErrorCollection_size(self)

    def at(self, *args):
        return _services.KernelErrorCollection_at(self, *args)
    __swig_destroy__ = _services.delete_KernelErrorCollection
    __del__ = lambda self: None

    def getDescription(self):
        return _services.KernelErrorCollection_getDescription(self)
KernelErrorCollection_swigregister = _services.KernelErrorCollection_swigregister
KernelErrorCollection_swigregister(KernelErrorCollection)

class Status(_object):
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Status, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Status, name)
    __repr__ = _swig_repr
    __swig_destroy__ = _services.delete_Status
    __del__ = lambda self: None

    def ok(self):
        return _services.Status_ok(self)
    def __nonzero__(self):
        return _services.Status___nonzero__(self)
    __bool__ = __nonzero__



    def add(self, *args):
        return _services.Status_add(self, *args)

    def __ior__(self, other):
        return _services.Status___ior__(self, other)

    def getDescription(self):
        return _services.Status_getDescription(self)

    def clear(self):
        return _services.Status_clear(self)

    def __init__(self, *args):
        this = _services.new_Status(*args)
        try:
            self.this.append(this)
        except:
            self.this = this

    def getCollection(self):
        return _services.Status_getCollection(self)
Status_swigregister = _services.Status_swigregister
Status_swigregister(Status)


def throwIfPossible(s):
    return _services.throwIfPossible(s)
throwIfPossible = _services.throwIfPossible

_services.sse2_swigconstant(_services)
sse2 = _services.sse2

_services.ssse3_swigconstant(_services)
ssse3 = _services.ssse3

_services.sse42_swigconstant(_services)
sse42 = _services.sse42

_services.avx_swigconstant(_services)
avx = _services.avx

_services.avx2_swigconstant(_services)
avx2 = _services.avx2

_services.avx512_mic_swigconstant(_services)
avx512_mic = _services.avx512_mic

_services.avx512_swigconstant(_services)
avx512 = _services.avx512

_services.avx512_mic_e1_swigconstant(_services)
avx512_mic_e1 = _services.avx512_mic_e1

_services.lastCpuType_swigconstant(_services)
lastCpuType = _services.lastCpuType
class Environment(daal.Base):
    __swig_setmethods__ = {}
    for _s in [daal.Base]:
        __swig_setmethods__.update(getattr(_s, '__swig_setmethods__', {}))
    __setattr__ = lambda self, name, value: _swig_setattr(self, Environment, name, value)
    __swig_getmethods__ = {}
    for _s in [daal.Base]:
        __swig_getmethods__.update(getattr(_s, '__swig_getmethods__', {}))
    __getattr__ = lambda self, name: _swig_getattr(self, Environment, name)

    def __init__(self, *args, **kwargs):
        raise AttributeError("No constructor defined")
    __repr__ = _swig_repr
    __swig_getmethods__["getInstance"] = lambda x: _services.Environment_getInstance
    if _newclass:
        getInstance = staticmethod(_services.Environment_getInstance)
    __swig_getmethods__["freeInstance"] = lambda x: _services.Environment_freeInstance
    if _newclass:
        freeInstance = staticmethod(_services.Environment_freeInstance)
    cpu_default = _services.Environment_cpu_default
    avx512_mic = _services.Environment_avx512_mic
    avx512 = _services.Environment_avx512
    avx512_mic_e1 = _services.Environment_avx512_mic_e1

    def getCpuId(self, *args):
        return _services.Environment_getCpuId(self, *args)

    def setCpuId(self, cpuid):
        return _services.Environment_setCpuId(self, cpuid)

    def enableInstructionsSet(self, enable):
        return _services.Environment_enableInstructionsSet(self, enable)
    MultiThreaded = _services.Environment_MultiThreaded
    SingleThreaded = _services.Environment_SingleThreaded

    def setDynamicLibraryThreadingTypeOnWindows(self, type):
        return _services.Environment_setDynamicLibraryThreadingTypeOnWindows(self, type)

    def setNumberOfThreads(self, numThreads):
        return _services.Environment_setNumberOfThreads(self, numThreads)

    def enableThreadPinning(self, enableThreadPinningFlag=True):
        return _services.Environment_enableThreadPinning(self, enableThreadPinningFlag)

    def getNumberOfThreads(self):
        return _services.Environment_getNumberOfThreads(self)

    def setMemoryLimit(self, type, limit):
        return _services.Environment_setMemoryLimit(self, type, limit)
    __swig_destroy__ = _services.delete_Environment
    __del__ = lambda self: None
Environment_swigregister = _services.Environment_swigregister
Environment_swigregister(Environment)

def Environment_getInstance():
    return _services.Environment_getInstance()
Environment_getInstance = _services.Environment_getInstance

def Environment_freeInstance():
    return _services.Environment_freeInstance()
Environment_freeInstance = _services.Environment_freeInstance

class Collection_SerializationIfacePtr(_object):
    r"""
This class is an alias of Collection(DataType=daal.data_management.SerializationIfacePtr)
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Collection_SerializationIfacePtr, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Collection_SerializationIfacePtr, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _services.new_Collection_SerializationIfacePtr(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _services.delete_Collection_SerializationIfacePtr
    __del__ = lambda self: None

    def size(self):
        return _services.Collection_SerializationIfacePtr_size(self)

    def capacity(self):
        return _services.Collection_SerializationIfacePtr_capacity(self)

    def get(self, *args):
        return _services.Collection_SerializationIfacePtr_get(self, *args)

    def push_back(self, x):
        return _services.Collection_SerializationIfacePtr_push_back(self, x)

    def __lshift__(self, x):
        return _services.Collection_SerializationIfacePtr___lshift__(self, x)

    def resize(self, newCapacity):
        return _services.Collection_SerializationIfacePtr_resize(self, newCapacity)

    def clear(self):
        return _services.Collection_SerializationIfacePtr_clear(self)

    def insert(self, *args):
        return _services.Collection_SerializationIfacePtr_insert(self, *args)

    def erase(self, pos):
        return _services.Collection_SerializationIfacePtr_erase(self, pos)

    def __getitem__(self, i):
        return _services.Collection_SerializationIfacePtr___getitem__(self, i)

    def __setitem__(self, i, v):
        return _services.Collection_SerializationIfacePtr___setitem__(self, i, v)
Collection_SerializationIfacePtr_swigregister = _services.Collection_SerializationIfacePtr_swigregister
Collection_SerializationIfacePtr_swigregister(Collection_SerializationIfacePtr)

class Collection_DataBlock(_object):
    r"""
This class is an alias of Collection(DataType=daal.services.SharedPtr__daal.data_management.DataBlock)
    """
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, Collection_DataBlock, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, Collection_DataBlock, name)
    __repr__ = _swig_repr

    def __init__(self, *args):
        this = _services.new_Collection_DataBlock(*args)
        try:
            self.this.append(this)
        except:
            self.this = this
    __swig_destroy__ = _services.delete_Collection_DataBlock
    __del__ = lambda self: None

    def size(self):
        return _services.Collection_DataBlock_size(self)

    def capacity(self):
        return _services.Collection_DataBlock_capacity(self)

    def get(self, *args):
        return _services.Collection_DataBlock_get(self, *args)

    def push_back(self, x):
        return _services.Collection_DataBlock_push_back(self, x)

    def __lshift__(self, x):
        return _services.Collection_DataBlock___lshift__(self, x)

    def resize(self, newCapacity):
        return _services.Collection_DataBlock_resize(self, newCapacity)

    def clear(self):
        return _services.Collection_DataBlock_clear(self)

    def insert(self, *args):
        return _services.Collection_DataBlock_insert(self, *args)

    def erase(self, pos):
        return _services.Collection_DataBlock_erase(self, pos)

    def __getitem__(self, i):
        return _services.Collection_DataBlock___getitem__(self, i)

    def __setitem__(self, i, v):
        return _services.Collection_DataBlock___setitem__(self, i, v)
Collection_DataBlock_swigregister = _services.Collection_DataBlock_swigregister
Collection_DataBlock_swigregister(Collection_DataBlock)

from numpy import float64, float32, intc

class Collection(object):
    r"""Factory class for different types of Collection."""
    def __new__(cls,
                DataType,
                *args, **kwargs):
        if DataType == daal.data_management.SerializationIfacePtr:
            return Collection_SerializationIfacePtr(*args)
        if DataType == daal.services.SharedPtr__daal.data_management.DataBlock:
            return Collection_DataBlock(*args)

        raise RuntimeError("No appropriate constructor found for Collection")


# This file is compatible with both classic and new-style classes.


